
var ipNew = "";
var urlGlobal = "";
var keyGlobal = "";
var saltGlobal = "";
var finalLink = "";


browser.webRequest.onBeforeRequest.addListener(
    redirect,
    {urls: ["<all_urls>"]},
    ["blocking"]
);

function openPage() {
  browser.tabs.create({
    url: "options.html"
  });
}

browser.browserAction.onClicked.addListener(openPage);


function saveOptions(e) {
    e.preventDefault();
    console.log("---Saving options---");
    
    browser.storage.sync.set({    
        url: document.querySelector("#url").value,
        salt: document.querySelector("#salt").value
    });
}

function restoreOptions() {
    
    function setCurrentChoice(result) {
        if(result.url) {
            console.log("URL restore: " + result.url);
            document.querySelector("#url").value = result.url;
        }
        
        if(result.key) {
            console.log("Key restore: " + result.key);
            document.querySelector("#key").value = result.key ;
        }
        
        if(result.salt) {
            console.log("Salt restore: " + result.salt);
            document.querySelector("#salt").value = result.salt ;
        }
    }

    let getting = browser.storage.sync.get("url");
    getting.then(setCurrentChoice);
  
    getting = browser.storage.sync.get("key");
    getting.then(setCurrentChoice);
  
    getting = browser.storage.sync.get("salt");
    getting.then(setCurrentChoice);
}

document.addEventListener("DOMContentLoaded", restoreOptions);
document.querySelector("form").addEventListener("submit", saveOptions);


function gettingCurrentHexValue() {
    var timeInSec = new Date().getTime()/1000;
    var timeNowMin = Math.floor((timeInSec / 60.0)).toString();
  
    console.log(timeNowMin);
  
    var keyValue = "";
    
    var valueStr = timeNowMin + keyGlobal + saltGlobal;
    console.log("All val: " + valueStr);
    // var hexaVal = SHA1(valueStr);
    var hexaVal = sha256(valueStr).substring(0, 40);
   
    return hexaVal;
}



async function findAddress(requestDetails){
    //console.log(requestDetails.url);
    async function onGot(item) {
        if (item.url) {
            console.log("Setting URL on got: " + item.url);
            urlGlobal = item.url;
        }
  
        if(item.key) {
            console.log("Setting key on got: " + item.key);
            keyGlobal = item.key;
        }
  
        if(item.salt) {
            console.log("Setting salt on got: " + item.salt);
            saltGlobal = item.salt;
        }  
    };
  
    let getting = browser.storage.sync.get("url");
    await getting.then(onGot);

    getting = browser.storage.sync.get("key");
    await getting.then(onGot);

    getting = browser.storage.sync.get("salt");
    await getting.then(onGot);
    
    
    var pattern = urlGlobal + "/*";
  
    if (requestDetails.url.match(pattern)) {
        console.log("Matched");
        var webLink = urlGlobal.replace("https://", "").replace("http://", "").replace("/", "");      
        console.log(webLink);
             
        var hexaVal = gettingCurrentHexValue();
        console.log(hexaVal);
 	
        finalLink = hexaVal.substring(0, 64) + "." + webLink;
        
        if (requestDetails.url.includes("https")) {
            finalLink = "https://" + finalLink;
        } else {
            finalLink = "http://" + finalLink;
        }
        
        console.log(finalLink);
        
    } else {
        console.log("Not Matched");
        finalLink = "";
    }
    
    return;
};


async function redirect(requestDetails) {
    console.log("Redirecting...: " + requestDetails.url);
    
    await findAddress(requestDetails);
    console.log("After await: " + finalLink);
    if (finalLink !== "") {
        return {redirectUrl: finalLink};
    }
};

