# Chhoyhopper-client 
This program finds the valid weblink to connect to a moving server.

Maintained by [ASM Rizvi](asmrizvi@usc.edu).

# Description
This Chhoyhopper client redirects the HTTP/HTTPS requests to the right weblink.
An IPv6 web server will be hopping over different IPv6 addresses running 
the service on different weblinks at different times. 
This browser add-on will find out the correct, current weblink,
which is a function of the time, shared secret, and salt.
Server and client must share the key before making the connection.

# Libraries
This Chhoyhopper extension uses two open spource libraries: SHA-1 and ipaddr.
We thank the authors of those two libraries.

# Example
After installing the addon, the client will see an IP6 icon. 
You can give the web page address to redirect, key file and salt value by clicking 
the icon and save them. The web page with the given web address will be redirected 
to the right weblink to get the service. 

This extension will redirect any web requests that contain the given web address.
For example, having https://hop.ant.isi.edu as an input, the extension will redirect 
anything with this address: https://hop.ant.isi.edu/*.
